//////////////////////////////////////////////////////////////////////////
//                                                                      //
// acos.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

//      acos

//      /   
//  (    )
static ULONG _DKK[26]={	0x36c7395e64b701fc,	0x2d8e72bcc96e03f9,	0x2b616f28eaf9a651,	0x2ad8391283abdb8c,
					0x2ab60c19a80f316b,	0x2aad82e3bc804568,	0x2aab60b6c45001a0,	0x2aaad82d8e67200f,
					0x2aaab60b616efa81,	0x2aaaad82d83911ca,	0x2aaaab60b60c19a5,	0x2aaaaad82d82e3bc,
					0x2aaaaab60b60b6c4,	0x2aaaaaad82d82d8e,	0x2aaaaaab60b60b61,	0x2aaaaaaad82d82d8,
					0x2aaaaaaab60b60b6,	0x2aaaaaaaad82d82d,	0x2aaaaaaaab60b60b,	0x2aaaaaaaaad82d83,
					0x2aaaaaaaaab60b60,	0x2aaaaaaaaaad82d8,	0x2aaaaaaaaaab60b6,	0x2aaaaaaaaaaad82d,
					0x2aaaaaaaaaaab60b,	0x2aaaaaaaaaaaad83};

//        float,
//      
static ULONG _DDKK[26]={	0x3ffb639caf325b81,	0x3ff6c7395e64b702,	0x3ff5b0b794757cd3,	0x3ff56c1c8941d5ee,
					0x3ff55b060cd40799,	0x3ff556c171de4023,	0x3ff555b05b622801,	0x3ff5556c16c73390,	
					0x3ff5555b05b0b77d,	0x3ff55556c16c1c89,	0x3ff55555b05b060d,	0x3ff555556c16c172,
					0x3ff555555b05b05b,	0x3ff5555556c16c17,	0x3ff5555555b05b06,	0x3ff55555556c16c1,	
					0x3ff55555555b05b0,	0x3ff555555556c16c,	0x3ff555555555b05b,	0x3ff5555555556c17,	
					0x3ff5555555555b06,	0x3ff55555555556c1,	0x3ff55555555555b0,	0x3ff555555555556c,	
					0x3ff555555555555b,	0x3ff5555555555557};

//   
//  DTBL[i] = atan(1./pow(2,i)) * ((LONG)1 << i) * 0x4000000000000000
extern LONG _iDTBL[90];

#ifdef __cplusplus
extern "C" {
#endif

// acos --
//
//    
//
//    --.
//    CORDIC,    .

double acos (double f){
	LONG Mnt;               //   
    LONG x, y;              //    
    LONG t;                 //       
    LONG XKK;               //    * 
    LONG atan;              //      
	int Exp, Sgn;           //     
	int NewExp;             //   
	int i;                  //     
    int j;                  //  ,    
	LONG rez = 0;           //   
	int iMj, iPj;           //      i-j, i+j

    //   double
	DstrDouble( f, Mnt, Exp, Sgn );

	//  
	if ( !Exp && Mnt == 0x0010000000000000  )	// +-1:  pi, 0	
		if (Sgn)
			return ConstructDouble( 0x003243f6a8885a31, 0, Sgn, 0);
		else
			return ConstructDouble( 0, 0, 0, 0);

	if ( Exp >-1  ){	// |x|>1 :  NAN
		_FPIEEE_Signal( _FPIEEE_Invalid ); 
		return ConstructDouble( 1, 0x400, 0, 0);
	}

	if ( Exp < -53 )			//    
		return ConstructDouble( 0x001921fb54442d18, 0, 0, 0);

	x = 0;
	y = 0;
	NewExp = 0;
	j=0;
    //      ( )
    if (Exp<-1 || Mnt<0x00114a280fb5068c)
		j=0;
	else if (Mnt<0x001c1528065b7d50)
		j=1;
	else if (Mnt<0x001f01549f7deea1)
		j=2;
	else if (Mnt<0x001fc015527d5bd3)
		j=3;
	else if (Mnt<0x001ff0015549f4d3)
		j=4;
	else if (Mnt<0x001ffc00155527d3)
		j=5;
	else if (Mnt<0x001fff000155549f)
		j=6;
	else if (Mnt<0x001fffc000155552)
		j=7;
	else if (Mnt<0x001ffff000015555)
		j=8;
	else if (Mnt<0x001ffffc00001555)
		j=9;
	else if (Mnt<0x001fffff00000155)
		j=10;
	else if (Mnt<0x001fffffc0000015)
		j=11;
	else if (Mnt<0x001ffffff0000001)
		j=12;
	else if (Mnt<0x001ffffffc000000)
		j=13;
	else if (Mnt<0x001fffffff000000)
		j=14;
	else if (Mnt<0x001fffffffc00000)
		j=15;
	else if (Mnt<0x001ffffffff00000)
		j=16;
	else if (Mnt<0x001ffffffffc0000)
		j=17;
	else if (Mnt<0x001fffffffff0000)
		j=18;
	else if (Mnt<0x001fffffffffc000)
		j=19;
	else if (Mnt<0x001ffffffffff000)
		j=20;
	else if (Mnt<0x001ffffffffffc00)
		j=21;
	else if (Mnt<0x001fffffffffff00)
		j=22;
	else if (Mnt<0x001fffffffffffc0)
		j=23;
	else if (Mnt<0x001ffffffffffff0)
		j=24;
	else 
		j=25;

	i=j;

    //      
	if (Exp<-9)
		Mnt>>= -Exp-9;
	else
		Mnt<<= Exp+9;
	LONG Uno = 0x2000000000000000;
	
    //      . 
	LONG TMP = LONG(double(0x2000000000000000-Mnt) * (*(double*)&_DDKK[j]));
	XKK = -(_DKK[j]) + 
		((0x2000000000000000-Mnt)<<(j<<1)) +
		TMP;

//    CORDIC,    .
	while (i-j<64){

		iMj = i - j;
		atan = _iDTBL[i]>>iMj;
		iPj = i + j;

		t = x;						//  
		if ( (x>XKK) == (y>=0) ){
			x -= y>>iMj;		//  
			y -= Uno;
			y += t>>iPj;
			rez -= atan;
		}
		else{
			x += y>>iMj;		//  
			y += Uno;
			y -= t>>iPj;
			rez += atan;
		}
		t = x;						//  
		if ( (x>XKK) == (y>=0) ){
			x -= y>>iMj;		//  
			y -= Uno;
			y += t>>iPj;
			rez -= atan;
		}
		else{
			x += y>>iMj;		//  
			y += Uno;
			y -= t>>iPj;
			rez += atan;
		}
		i++;
		Uno >>=1;
	}
    //      
    NewExp = -j+1;
	if (Sgn){
        //  acos(-x) = Pi - acos(x)
		while(NewExp<1){
			NewExp++;
			rez>>=1;
		}
		rez = 0x6487ed5110b4611a - rez;
	}

    //      
	if (rez!=0){
		while (!(rez & 0x4000000000000000)){
			rez <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -0x3ff;

    //     , ...  
    rez >>=9;
	//    ,  .
    rez = (rez>>1) + (rez & 1);
	if (rez == 0x0020000000000000){	
		rez = 0;
		NewExp++;
	}
    //   double
	return ConstructDouble( rez, NewExp, 0, 0);		
}

#ifdef __cplusplus
}
#endif
