//////////////////////////////////////////////////////////////////////////
//                                                                      //
// asinf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

//         
//  (    )
extern unsigned int _ASINKK[12];

//   
//  iTBL[i] = atan(1./pow(2,i)) * (1 << i) * 0x40000000
extern int _iTBL[42];

// asinf --
//
//    
//
//    --.
//    CORDIC,    .

#ifdef __cplusplus
extern "C" {
#endif

float asinf (float f){

	int Mnt;                    //   
    int x, y;                   //    
    int t;                      //       
    int YKK;                    //    * y
    int atan;                   //      
	int Exp, Sgn, Spc;          //  ,     
	int NewExp;                 //   
	int i;                      //     
    int j;                      //  ,    
	int rez = 0;                //   
	int iMj, iPj;               //      i-j, i+j
	LONG lK;                    //  YKK  
	unsigned int Arg;           //    (unsigned)

    //   float
    DestructFloat( f, Mnt, Exp, Sgn, Spc );

	//  
	if ( !Exp && Mnt == 0x00800000  )	// +-1:  +-pi/2
		return ConstructFloat( 0xC90FDB, 0, Sgn, 0);

	if ( Exp >-1  ){	// |x|>1 :  NAN
		_FPIEEE_Signal( _FPIEEE_Invalid ); 
		return ConstructFloat( 1, 0x80, 0, 0);
	}

	if ( Exp < -12 )			//    
		return f;			//	lim(x->0)(sin(x)) = x


    //      
    Arg = Mnt << 5;

	//     
    x = 0x20000000;
	y = 0;

    //      ( )
	NewExp = Exp+1;
	j=-NewExp;
	i=j;
	
    //      . 
    lK = LONG(_ASINKK[j]) * Arg;		
	YKK = int(lK>>30);

    //    CORDIC,    .
	while (i<0x20-j){
		iMj = i - j;
		atan = _iTBL[i]>>iMj;
		iPj = i + j;
		t = x;						//  
		if ( (y>=YKK) ^ (x<=0) ){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		t = x;						//  
		if ( (y>=YKK) ^ (x<=0) ){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		i++;
	}
	while (i<30+j){		/*  ?  -  i>=0x20-j 
						x  ,    (microsoft ++)	-
						    .*/
		iMj = i - j;
		atan = _iTBL[i]>>iMj;
		if ( (y>=YKK) ^ (x<=0) ){
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		if ( (y>=YKK) ^ (x<=0) ){	//  
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		i++;
	}
    //  asin(x) = 2*Pi - asin(x)
	if (rez>0x3243F6A8)
		rez = 0x6487ED51 - rez;

    //      
	if (rez!=0){
		while (!(rez & 0x20000000)){
			rez <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -127;

	//     , ...  
    rez >>=5;
	//    ,  .
	rez = (rez>>1) + (rez & 1);
	if (rez == 0x01000000){	
		rez = 0;
		NewExp++;
	}

    //   float
	return ConstructFloat( rez, NewExp, Sgn, 0);
}

#ifdef __cplusplus
}
#endif
