//////////////////////////////////////////////////////////////////////////
//                                                                      //
// floorf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:07p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// floorf --
//
//    ,     
//
float floorf(float f){
	int m, e, s, sc, r;

    //   float
    DestructFloat(f, m, e, s, sc);

    //    
    if (e < 0){
		if(s==0 || (m==0 && e==-127))
			return 0;
		else
			return -1;
	}

	//   
    if (e > 22){	
		return f;
	}
	
	sc = 23 - e;
	r = m & (0x00ffffff >> (e+1));
	m >>= sc;
	if (s && r)
		m++;        //    -  
	m <<= sc;

	if (m == 0x01000000){	
		m = 0;
		e++;
	}

    //   float
	return ConstructFloat(m, e, s, 0);
}

#ifdef __cplusplus
}
#endif
