//----------------------------------------------------------------
//
// Copyright (c) 1996-1998 RC Module Inc.
// NeuroChip NM6403.
//
// int1.asm
//    .
// ver 1.0.
//
// by Alexey A. Chelubeev
//
//----------------------------------------------------------------


    // called before main function.

begin ".init"

    local ___InitIntHandler : label;
        // call to initializing interrupt table before the call to 'main'.
    call ___InitIntHandler;

end ".init";


    //        .
const InterruptTable = 0;

    //    .
struct NM6403Context 
    regs : long[8];     //   .
end NM6403Context;

    //
    //    .
    //

data ".data"

    //   .   ,
    // ..   .
    //   .
global _InterruptVectors : long[5];

        //   .
        //       
        // ,     .
        // (   ).
global STACK : long[72] = ( 0l dup 72 );

    .align;
        //    .
global _SavedContext : NM6403Context = ( 
        (0cdcdcdcdcdcdcdcdhl dup 7),    // ar0,gr0 - ar6,gr6
        (STACK,0cdcdcdcdh)              // ar7, gr7
        );

        //  pc    
    savedPC : word = 0;
    Fill1 : word = -2;

end ".data";



    //
    //     .
    // 

begin ".text"


    //     .
    //      pc,psw.
    //  ar7  .

macro SaveRegs()

        // C    .

    [ _SavedContext.regs[0] ] = ar0,gr0;
    ar0 = _SavedContext.regs[1];
    [ar0++] = ar1,gr1;
    [ar0++] = ar2,gr2;
    [ar0++] = ar3,gr3;
    [ar0++] = ar4,gr4;
    [ar0++] = ar5,gr5;
    [ar0++] = ar6,gr6;
    [ar0++] = ar7,gr7;

end SaveRegs;


    //     .

macro RestoreRegs( )

        //     ar0,gr0.

	ar0 = _SavedContext.regs[1];
	ar1,gr1 = [ar0++];
	ar2,gr2 = [ar0++];
	ar3,gr3 = [ar0++];
	ar4,gr4 = [ar0++];
	ar5,gr5 = [ar0++];
	ar6,gr6 = [ar0++];
	ar7,gr7 = [ar0++];

        //   ar0,gr0.

    ar0,gr0 = [ _SavedContext.regs[0] ];

end RestoreRegs;


//
// SET_NORMAL_PSWR() -
//
//       
//   .
//

macro SET_NORMAL_PSWR()

        //   .
        //    V  PSW (  ).
        //        
        //     .
    pswr clear 00000ffffh;

        //     .
    pswr set   0c0000000h;

end SET_NORMAL_PSWR;

//----------------------------------------------------------------------//
//                                                                      //
// DefIntHandler -                                                      //
//         .                     //
//                                                                      //
// :                                                           //
//           _InterruptVectors.    //
//          pc          //
//      savedPC      .        //
//                                                                      //
//  :                                                    //
//          .              //
//         .                                    //
//                                                                      //
//----------------------------------------------------------------------//

<DefIntHandler>


        //    pswr.
    SET_NORMAL_PSWR();

        //  .
    SaveRegs();

    ar7 = STACK;
    ar1 = _InterruptVectors;
    gr2 = 1;
    gr0 = [ savedPC ];

        //    .
    with gr1 = gr0 >> 3;

        //   ,    
        //  V   ,    
        // .
    with gr2 = gr2 - gr1;
    if =0 callrel AvoidOverflowBug; 

       //  ,  .
    gr0 = [ar1 += gr1];

    with gr0;
    if <>0 call gr0;

    RestoreRegs( );  //     .

    ireturn;

    //  .    V.
    //    V     pswr.
<AvoidOverflowBug>
    ar6 = [ _SavedContext + 14 ];  //   ar7
    gr3 = 2h;                      //    V
    ar6 = ar6 - 1;                 //     pswr.
	
    delayed return;
    gr2 = [ ar6 ];
    with gr2 = gr2 and not gr3;
    [ ar6 ] = gr2;
    // end of delayed return.


//----------------------------------------------------------------------//
//                                                                      //
//   DefIntHandler.                                       //
//                                                                      //
//----------------------------------------------------------------------//

    
//----------------------------------------------------------------------//
//                                                                      //
// ___InitIntHandler -                                                  //
//                    //
//                                                                      //
// :                                                           //
//           .    //
//          InitDataInt.                       //
//      savedPC      .        //
//                                                                      //
//  :                                                    //
//      .                                                            //
//                                                                      //
//----------------------------------------------------------------------//

<InitDataInt>
	  //   
    [ savedPC ] = pc;
    delayed goto DefIntHandler;
    nul 32;
    nul 32;


local ___InitIntHandler : label;
<___InitIntHandler>
        //   
    [ar7++] = ar6,gr6;
    [ar7++] = ar4,gr4;

    ar6 = InterruptTable;
    gr6 = 10;

<IntInitStart>
        //    
    ar5 = InitDataInt;

    ar4,gr4 = [ar5++];
    [ar6++] = ar4,gr4;

    ar4,gr4 = [ar5++];
    [ar6++] = ar4,gr4;

    ar4,gr4 = [ar5++];
    [ar6++] = ar4,gr4;

    ar4,gr4 = [ar5++] with gr6 = gr6 - 1;
    [ar6++] = ar4,gr4;
	
    if <>0 goto IntInitStart;

       //       
    ar4,gr4 = 0;
    ar6 = _InterruptVectors;
    [ar6++] = ar4,gr4;
    [ar6++] = ar4,gr4;
    [ar6++] = ar4,gr4;
    [ar6++] = ar4,gr4;
    [ar6++] = ar4,gr4;

        //   
    ar4,gr4 = [--ar7];
    ar6,gr6 = [--ar7];

    return;

end ".text";


begin ".text"

//----------------------------------------------------------------------//
//                                                                      //
// _EnableInterrupts -                                                  //
// extern "C" void EnableInterrupts ( int mask );                       //
//          .                 //
//                                                                      //
// :                                                           //
//         psw,   ,     //
//        .                                    //
//                                                                      //
//  :                                                    //
//      .                                                            //
//                                                                      //
//----------------------------------------------------------------------//

global _EnableInterrupts : label;
<_EnableInterrupts>
	  //   .
	[ar7++] = ar6,gr6;

	ar6 = ar7 - 5;
	gr6 = [ar6];  //    gr6.

	  //  ,   .
	gr7 = pswr;
	with gr7 = gr7 or gr6;
	pswr = gr7;

	  //   .
	ar6,gr6 = [--ar7];

	return;

//----------------------------------------------------------------------//
//                                                                      //
// _DisableInterrupts -                                                 //
// extern "C" void DisableInterrupts ( int mask );                      //
//          .                 //
//                                                                      //
// :                                                           //
//         psw,   ,     //
//        .                                    //
//                                                                      //
//  :                                                    //
//      .                                                            //
//                                                                      //
//----------------------------------------------------------------------//

global _DisableInterrupts : label;

<_DisableInterrupts>
	    //   .
	[ar7++] = ar6,gr6;

	ar6 = ar7 - 5;
	gr6 = [ar6];

	  //  ,   mask.
	gr7 = pswr;
	with gr7 = gr7 and not gr6;
	pswr = gr7;

	  //   .
	ar6,gr6 = [--ar7];

	return;

//----------------------------------------------------------------------//
//                                                                      //
// _GetInterruptMask -                                                  //
// extern "C" int GetInterruptMask( void );                             //
//        .                                    //
//                                                                      //
// :                                                           //
//        psw   / . //
//                                                                      //
//  :                                                    //
//      .                                                            //
//                                                                      //
//----------------------------------------------------------------------//

global _GetInterruptMask : label;

<_GetInterruptMask>
	    //   .
	[ar7++] = ar6,gr6;

	    //     4  13  pswr.
	gr7 = pswr;
	gr6 = 03ff0h;
	with gr7 = gr7 and gr6;

	    //   .
	ar6,gr6 = [--ar7];

	return;

end ".text";
